Linux Audio

Check our new training course

Loading...
v6.8
  1#!/usr/bin/env bash
  2# SPDX-License-Identifier: GPL-2.0
  3# Linux kernel coccicheck
  4#
  5# Read Documentation/dev-tools/coccinelle.rst
  6#
  7# This script requires at least spatch
  8# version 1.0.0-rc11.
  9
 10DIR="$(dirname $(readlink -f $0))/.."
 11SPATCH="`which ${SPATCH:=spatch}`"
 12
 13if [ ! -x "$SPATCH" ]; then
 14    echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
 15    exit 1
 16fi
 17
 18SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
 
 19
 20USE_JOBS="no"
 21$SPATCH --help | grep -e "--jobs" > /dev/null && USE_JOBS="yes"
 22
 23# The verbosity may be set by the environmental parameter V=
 24# as for example with 'make V=1 coccicheck'
 25
 26if [ -n "$V" -a "$V" != "0" ]; then
 27	VERBOSE="$V"
 28else
 29	VERBOSE=0
 30fi
 31
 
 
 
 
 
 
 32FLAGS="--very-quiet"
 33
 34# You can use SPFLAGS to append extra arguments to coccicheck or override any
 35# heuristics done in this file as Coccinelle accepts the last options when
 36# options conflict.
 37#
 38# A good example for use of SPFLAGS is if you want to debug your cocci script,
 39# you can for instance use the following:
 40#
 41# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
 42# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
 43#
 44# "--show-trying" should show you what rule is being processed as it goes to
 45# stdout, you do not need a debug file for that. The profile output will be
 46# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
 47# inspected there.
 48#
 49# --profile will not output if --very-quiet is used, so avoid it.
 50echo $SPFLAGS | grep -E -e "--profile|--show-trying" 2>&1 > /dev/null
 51if [ $? -eq 0 ]; then
 52	FLAGS="--quiet"
 53fi
 54
 55# spatch only allows include directories with the syntax "-I include"
 56# while gcc also allows "-Iinclude" and "-include include"
 57COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
 58COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
 59
 60if [ "$C" = "1" -o "$C" = "2" ]; then
 61    ONLINE=1
 62
 63    if [[ $# -le 0 ]]; then
 64	    echo ''
 65	    echo 'Specifying both the variable "C" and rule "coccicheck" in the make
 66command results in a shift count error.'
 67	    echo ''
 68	    echo 'Try specifying "scripts/coccicheck" as a value for the CHECK variable instead.'
 69	    echo ''
 70	    echo 'Example:	make C=2 CHECK=scripts/coccicheck drivers/net/ethernet/ethoc.o'
 71	    echo ''
 72	    exit 1
 73    fi
 74
 75    # Take only the last argument, which is the C file to test
 76    shift $(( $# - 1 ))
 77    OPTIONS="$COCCIINCLUDE $1"
 78
 79    # No need to parallelize Coccinelle since this mode takes one input file.
 80    NPROC=1
 81else
 82    ONLINE=0
 83    if [ "$KBUILD_EXTMOD" = "" ] ; then
 84        OPTIONS="--dir $srctree $COCCIINCLUDE"
 85    else
 86        OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
 87    fi
 88
 89    # Use only one thread per core by default if hyperthreading is enabled
 90    THREADS_PER_CORE=$(LANG=C lscpu | grep "Thread(s) per core: " | tr -cd "[:digit:]")
 91    if [ -z "$J" ]; then
 92        NPROC=$(getconf _NPROCESSORS_ONLN)
 93	if [ $THREADS_PER_CORE -gt 1 -a $NPROC -gt 4 ] ; then
 94		NPROC=$((NPROC/2))
 95	fi
 96    else
 97        NPROC="$J"
 98    fi
 99fi
100
101if [ "$KBUILD_EXTMOD" != "" ] ; then
102    OPTIONS="--patch $srctree $OPTIONS"
103fi
104
105# You can override by using SPFLAGS
106if [ "$USE_JOBS" = "no" ]; then
107	trap kill_running SIGTERM SIGINT
108	declare -a SPATCH_PID
109elif [ "$NPROC" != "1" ]; then
110	# Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
111	# https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
112	OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
113fi
114
115if [ "$MODE" = "" ] ; then
116    if [ "$ONLINE" = "0" ] ; then
117	echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
118	echo 'Available modes are the following: patch, report, context, org, chain'
119	echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
120	echo 'Note however that some modes are not implemented by some semantic patches.'
121    fi
122    MODE="report"
123fi
124
125if [ "$MODE" = "chain" ] ; then
126    if [ "$ONLINE" = "0" ] ; then
127	echo 'You have selected the "chain" mode.'
128	echo 'All available modes will be tried (in that order): patch, report, context, org'
129    fi
130elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
131    FLAGS="--no-show-diff $FLAGS"
132fi
133
134if [ "$ONLINE" = "0" ] ; then
135    echo ''
136    echo 'Please check for false positives in the output before submitting a patch.'
137    echo 'When using "patch" mode, carefully review the patch before submitting it.'
138    echo ''
139fi
140
141run_cmd_parmap() {
142	if [ $VERBOSE -ne 0 ] ; then
143		echo "Running ($NPROC in parallel): $@"
144	fi
145	if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
146                echo $@>>$DEBUG_FILE
147                $@ 2>>$DEBUG_FILE
148        else
149                echo $@
150                $@ 2>&1
 
151	fi
152
153	err=$?
154	if [[ $err -ne 0 ]]; then
155		echo "coccicheck failed"
156		exit $err
157	fi
158}
159
160run_cmd_old() {
161	local i
162	if [ $VERBOSE -ne 0 ] ; then
163		echo "Running ($NPROC in parallel): $@"
164	fi
165	for i in $(seq 0 $(( NPROC - 1)) ); do
166		eval "$@ --max $NPROC --index $i &"
167		SPATCH_PID[$i]=$!
168		if [ $VERBOSE -eq 2 ] ; then
169			echo "${SPATCH_PID[$i]} running"
170		fi
171	done
172	wait
173}
174
175run_cmd() {
176	if [ "$USE_JOBS" = "yes" ]; then
177		run_cmd_parmap $@
178	else
179		run_cmd_old $@
180	fi
181}
182
183kill_running() {
184	for i in $(seq 0 $(( NPROC - 1 )) ); do
185		if [ $VERBOSE -eq 2 ] ; then
186			echo "Killing ${SPATCH_PID[$i]}"
187		fi
188		kill ${SPATCH_PID[$i]} 2>/dev/null
189	done
190}
191
192# You can override heuristics with SPFLAGS, these must always go last
193OPTIONS="$OPTIONS $SPFLAGS"
194
195coccinelle () {
196    COCCI="$1"
197
198    OPT=`grep "Options:" $COCCI | cut -d':' -f2`
199    REQ=`grep "Requires:" $COCCI | cut -d':' -f2 | sed "s| ||"`
200    if [ -n "$REQ" ] && ! { echo "$REQ"; echo "$SPATCH_VERSION"; } | sort -CV ; then
201	    echo "Skipping coccinelle SmPL patch: $COCCI"
202	    echo "You have coccinelle:           $SPATCH_VERSION"
203	    echo "This SmPL patch requires:      $REQ"
204	    return
 
 
 
205    fi
206
207#   The option '--parse-cocci' can be used to syntactically check the SmPL files.
208#
209#    $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
210
211    if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
212
213	FILE=${COCCI#$srctree/}
214
215	echo "Processing `basename $COCCI`"
216	echo "with option(s) \"$OPT\""
217	echo ''
218	echo 'Message example to submit a patch:'
219
220	sed -ne 's|^///||p' $COCCI
221
222	if [ "$MODE" = "patch" ] ; then
223	    echo ' The semantic patch that makes this change is available'
224	elif [ "$MODE" = "report" ] ; then
225	    echo ' The semantic patch that makes this report is available'
226	elif [ "$MODE" = "context" ] ; then
227	    echo ' The semantic patch that spots this code is available'
228	elif [ "$MODE" = "org" ] ; then
229	    echo ' The semantic patch that makes this Org report is available'
230	else
231	    echo ' The semantic patch that makes this output is available'
232	fi
233	echo " in $FILE."
234	echo ''
235	echo ' More information about semantic patching is available at'
236	echo ' http://coccinelle.lip6.fr/'
237	echo ''
238
239	if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
240	    echo 'Semantic patch information:'
241	    sed -ne 's|^//#||p' $COCCI
242	    echo ''
243	fi
244    fi
245
246    if [ "$MODE" = "chain" ] ; then
247	run_cmd $SPATCH -D patch   \
248		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
249	run_cmd $SPATCH -D report  \
250		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
251	run_cmd $SPATCH -D context \
252		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
253	run_cmd $SPATCH -D org     \
254		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
255    elif [ "$MODE" = "rep+ctxt" ] ; then
256	run_cmd $SPATCH -D report  \
257		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
258	run_cmd $SPATCH -D context \
259		$FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
260    else
261	run_cmd $SPATCH -D $MODE   $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
262    fi
263
264}
265
266if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
267	if [ -f $DEBUG_FILE ]; then
268		echo "Debug file $DEBUG_FILE exists, bailing"
269		exit
270	fi
271else
272	DEBUG_FILE="/dev/null"
273fi
274
275if [ "$COCCI" = "" ] ; then
276    for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
277	coccinelle $f
278    done
279else
280    coccinelle $COCCI
281fi
v4.10.11
  1#!/bin/bash
 
  2# Linux kernel coccicheck
  3#
  4# Read Documentation/dev-tools/coccinelle.rst
  5#
  6# This script requires at least spatch
  7# version 1.0.0-rc11.
  8
  9DIR="$(dirname $(readlink -f $0))/.."
 10SPATCH="`which ${SPATCH:=spatch}`"
 11
 12if [ ! -x "$SPATCH" ]; then
 13    echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
 14    exit 1
 15fi
 16
 17SPATCH_VERSION=$($SPATCH --version | head -1 | awk '{print $3}')
 18SPATCH_VERSION_NUM=$(echo $SPATCH_VERSION | ${DIR}/scripts/ld-version.sh)
 19
 20USE_JOBS="no"
 21$SPATCH --help | grep "\-\-jobs" > /dev/null && USE_JOBS="yes"
 22
 23# The verbosity may be set by the environmental parameter V=
 24# as for example with 'make V=1 coccicheck'
 25
 26if [ -n "$V" -a "$V" != "0" ]; then
 27	VERBOSE="$V"
 28else
 29	VERBOSE=0
 30fi
 31
 32if [ -z "$J" ]; then
 33	NPROC=$(getconf _NPROCESSORS_ONLN)
 34else
 35	NPROC="$J"
 36fi
 37
 38FLAGS="--very-quiet"
 39
 40# You can use SPFLAGS to append extra arguments to coccicheck or override any
 41# heuristics done in this file as Coccinelle accepts the last options when
 42# options conflict.
 43#
 44# A good example for use of SPFLAGS is if you want to debug your cocci script,
 45# you can for instance use the following:
 46#
 47# $ export COCCI=scripts/coccinelle/misc/irqf_oneshot.cocci
 48# $ make coccicheck MODE=report DEBUG_FILE="all.err" SPFLAGS="--profile --show-trying" M=./drivers/mfd/arizona-irq.c
 49#
 50# "--show-trying" should show you what rule is being processed as it goes to
 51# stdout, you do not need a debug file for that. The profile output will be
 52# be sent to stdout, if you provide a DEBUG_FILE the profiling data can be
 53# inspected there.
 54#
 55# --profile will not output if --very-quiet is used, so avoid it.
 56echo $SPFLAGS | egrep -e "--profile|--show-trying" 2>&1 > /dev/null
 57if [ $? -eq 0 ]; then
 58	FLAGS="--quiet"
 59fi
 60
 61# spatch only allows include directories with the syntax "-I include"
 62# while gcc also allows "-Iinclude" and "-include include"
 63COCCIINCLUDE=${LINUXINCLUDE//-I/-I }
 64COCCIINCLUDE=${COCCIINCLUDE// -include/ --include}
 65
 66if [ "$C" = "1" -o "$C" = "2" ]; then
 67    ONLINE=1
 68
 
 
 
 
 
 
 
 
 
 
 
 
 69    # Take only the last argument, which is the C file to test
 70    shift $(( $# - 1 ))
 71    OPTIONS="$COCCIINCLUDE $1"
 
 
 
 72else
 73    ONLINE=0
 74    if [ "$KBUILD_EXTMOD" = "" ] ; then
 75        OPTIONS="--dir $srctree $COCCIINCLUDE"
 76    else
 77        OPTIONS="--dir $KBUILD_EXTMOD $COCCIINCLUDE"
 78    fi
 
 
 
 
 
 
 
 
 
 
 
 79fi
 80
 81if [ "$KBUILD_EXTMOD" != "" ] ; then
 82    OPTIONS="--patch $srctree $OPTIONS"
 83fi
 84
 85# You can override by using SPFLAGS
 86if [ "$USE_JOBS" = "no" ]; then
 87	trap kill_running SIGTERM SIGINT
 88	declare -a SPATCH_PID
 89elif [ "$NPROC" != "1" ]; then
 90	# Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
 91	# https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
 92	OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
 93fi
 94
 95if [ "$MODE" = "" ] ; then
 96    if [ "$ONLINE" = "0" ] ; then
 97	echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
 98	echo 'Available modes are the following: patch, report, context, org'
 99	echo 'You can specify the mode with "make coccicheck MODE=<mode>"'
100	echo 'Note however that some modes are not implemented by some semantic patches.'
101    fi
102    MODE="report"
103fi
104
105if [ "$MODE" = "chain" ] ; then
106    if [ "$ONLINE" = "0" ] ; then
107	echo 'You have selected the "chain" mode.'
108	echo 'All available modes will be tried (in that order): patch, report, context, org'
109    fi
110elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
111    FLAGS="--no-show-diff $FLAGS"
112fi
113
114if [ "$ONLINE" = "0" ] ; then
115    echo ''
116    echo 'Please check for false positives in the output before submitting a patch.'
117    echo 'When using "patch" mode, carefully review the patch before submitting it.'
118    echo ''
119fi
120
121run_cmd_parmap() {
122	if [ $VERBOSE -ne 0 ] ; then
123		echo "Running ($NPROC in parallel): $@"
124	fi
125	if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
126		if [ -f $DEBUG_FILE ]; then
127			echo "Debug file $DEBUG_FILE exists, bailing"
128			exit
129		fi
130	else
131		DEBUG_FILE="/dev/null"
132	fi
133	$@ 2>$DEBUG_FILE
134	if [[ $? -ne 0 ]]; then
 
135		echo "coccicheck failed"
136		exit $?
137	fi
138}
139
140run_cmd_old() {
141	local i
142	if [ $VERBOSE -ne 0 ] ; then
143		echo "Running ($NPROC in parallel): $@"
144	fi
145	for i in $(seq 0 $(( NPROC - 1)) ); do
146		eval "$@ --max $NPROC --index $i &"
147		SPATCH_PID[$i]=$!
148		if [ $VERBOSE -eq 2 ] ; then
149			echo "${SPATCH_PID[$i]} running"
150		fi
151	done
152	wait
153}
154
155run_cmd() {
156	if [ "$USE_JOBS" = "yes" ]; then
157		run_cmd_parmap $@
158	else
159		run_cmd_old $@
160	fi
161}
162
163kill_running() {
164	for i in $(seq 0 $(( NPROC - 1 )) ); do
165		if [ $VERBOSE -eq 2 ] ; then
166			echo "Killing ${SPATCH_PID[$i]}"
167		fi
168		kill ${SPATCH_PID[$i]} 2>/dev/null
169	done
170}
171
172# You can override heuristics with SPFLAGS, these must always go last
173OPTIONS="$OPTIONS $SPFLAGS"
174
175coccinelle () {
176    COCCI="$1"
177
178    OPT=`grep "Option" $COCCI | cut -d':' -f2`
179    REQ=`grep "Requires" $COCCI | cut -d':' -f2 | sed "s| ||"`
180    REQ_NUM=$(echo $REQ | ${DIR}/scripts/ld-version.sh)
181    if [ "$REQ_NUM" != "0" ] ; then
182	    if [ "$SPATCH_VERSION_NUM" -lt "$REQ_NUM" ] ; then
183		    echo "Skipping coccinele SmPL patch: $COCCI"
184		    echo "You have coccinelle:           $SPATCH_VERSION"
185		    echo "This SmPL patch requires:      $REQ"
186		    return
187	    fi
188    fi
189
190#   The option '--parse-cocci' can be used to syntactically check the SmPL files.
191#
192#    $SPATCH -D $MODE $FLAGS -parse_cocci $COCCI $OPT > /dev/null
193
194    if [ $VERBOSE -ne 0 -a $ONLINE -eq 0 ] ; then
195
196	FILE=`echo $COCCI | sed "s|$srctree/||"`
197
198	echo "Processing `basename $COCCI`"
199	echo "with option(s) \"$OPT\""
200	echo ''
201	echo 'Message example to submit a patch:'
202
203	sed -ne 's|^///||p' $COCCI
204
205	if [ "$MODE" = "patch" ] ; then
206	    echo ' The semantic patch that makes this change is available'
207	elif [ "$MODE" = "report" ] ; then
208	    echo ' The semantic patch that makes this report is available'
209	elif [ "$MODE" = "context" ] ; then
210	    echo ' The semantic patch that spots this code is available'
211	elif [ "$MODE" = "org" ] ; then
212	    echo ' The semantic patch that makes this Org report is available'
213	else
214	    echo ' The semantic patch that makes this output is available'
215	fi
216	echo " in $FILE."
217	echo ''
218	echo ' More information about semantic patching is available at'
219	echo ' http://coccinelle.lip6.fr/'
220	echo ''
221
222	if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
223	    echo 'Semantic patch information:'
224	    sed -ne 's|^//#||p' $COCCI
225	    echo ''
226	fi
227    fi
228
229    if [ "$MODE" = "chain" ] ; then
230	run_cmd $SPATCH -D patch   \
231		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
232	run_cmd $SPATCH -D report  \
233		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
234	run_cmd $SPATCH -D context \
235		$FLAGS --cocci-file $COCCI $OPT $OPTIONS               || \
236	run_cmd $SPATCH -D org     \
237		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
238    elif [ "$MODE" = "rep+ctxt" ] ; then
239	run_cmd $SPATCH -D report  \
240		$FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
241	run_cmd $SPATCH -D context \
242		$FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
243    else
244	run_cmd $SPATCH -D $MODE   $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
245    fi
246
247}
 
 
 
 
 
 
 
 
 
248
249if [ "$COCCI" = "" ] ; then
250    for f in `find $srctree/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
251	coccinelle $f
252    done
253else
254    coccinelle $COCCI
255fi